Index: npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest
===================================================================
--- npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision cd8630be6536b27ae1c762184795ee87723202ab)
+++ npl/mailserver/netqmail/roberto-netqmail-1.06.patch-latest	(revision 1ebb340be23e45ead361b729734f0e82007af6bd)
@@ -7541,6 +7898,5 @@
 +	strcpy(opts.szRequiredHeaders, "NonExistent");
 +	opts.pfnHeaderCallback = SignThisHeader;
-+	while (1)
-+	{
++	while (1) {
 +		if ((ch = getopt(argc, argv, "lqtfhHSvVp:b:c:d:i:s:x:y:z:")) == -1)
 +			break;
@@ -7548,4 +7904,5 @@
 +		{
 +		case 'l': /*- body length tag */
++			vopts.nHonorBodyLengthTag = 1;
 +			opts.nIncludeBodyLengthTag = 1;
 +			break;
@@ -7684,6 +8041,5 @@
 +	}
 +	if (bSign) { /*- sign */
-+		if (!PrivKeyFile)
-+		{
++		if (!PrivKeyFile) {
 +			fprintf(stderr, "Private Key not provided\n");
 +			usage();
@@ -7701,16 +8057,13 @@
 +			return (1);
 +		}
-+		if (fstat(PrivKeyFD, &statbuf) == -1)
-+		{
++		if (fstat(PrivKeyFD, &statbuf) == -1) {
 +			fprintf(stderr, "fstat: %s: %s\n", PrivKeyFile, strerror(errno));
 +			return (1);
 +		}
-+		if (!(PrivKey = (char *) DKIM_MALLOC(sizeof(char) * ((nPrivKeyLen = statbuf.st_size) + 1))))
-+		{
++		if (!(PrivKey = (char *) DKIM_MALLOC(sizeof(char) * ((nPrivKeyLen = statbuf.st_size) + 1)))) {
 +			fprintf(stderr, "malloc: %ld bytes: %s\n", statbuf.st_size + 1, strerror(errno));
 +			return (1);
 +		}
-+		if (read(PrivKeyFD, PrivKey, nPrivKeyLen) != nPrivKeyLen)
-+		{
++		if (read(PrivKeyFD, PrivKey, nPrivKeyLen) != nPrivKeyLen) {
 +			fprintf(stderr, "%s: read: %s\n", strerror(errno), program);
 +			return (1);
@@ -7718,13 +8071,10 @@
 +		close(PrivKeyFD);
 +		PrivKey[nPrivKeyLen] = '\0';
-+		if (DKIMSignInit(&ctxt, &opts) != DKIM_SUCCESS)
-+		{
++		if (DKIMSignInit(&ctxt, &opts) != DKIM_SUCCESS) {
 +			fprintf(stderr, "DKIMSignInit: failed to initialize signature %s\n", PrivKeyFile);
 +			return (1);
 +		}
-+		for (;;)
-+		{
-+			if ((ret = read(0, Buffer, sizeof(Buffer) - 1)) == -1)
-+			{
++		for (;;) {
++			if ((ret = read(0, Buffer, sizeof(Buffer) - 1)) == -1) {
 +				fprintf(stderr, "read: %s\n", strerror(errno));
 +				DKIMSignFree(&ctxt);
@@ -7733,6 +8083,5 @@
 +			if (!ret)
 +				break;
-+			if (DKIMSignProcess(&ctxt, Buffer, ret) == DKIM_INVALID_CONTEXT)
-+			{
++			if (DKIMSignProcess(&ctxt, Buffer, ret) == DKIM_INVALID_CONTEXT) {
 +				fprintf(stderr, "DKIMSignProcess: DKIMContext structure invalid for this operation\n");
 +				DKIMSignFree(&ctxt);
@@ -7740,12 +8089,10 @@
 +			}
 +		}
-+		if (DKIMSignGetSig2(&ctxt, PrivKey, &pSig) == DKIM_INVALID_CONTEXT)
-+		{
++		if (DKIMSignGetSig2(&ctxt, PrivKey, &pSig) == DKIM_INVALID_CONTEXT) {
 +			fprintf(stderr, "DKIMSignProcess: DKIMContext structure invalid for this operation\n");
 +			DKIMSignFree(&ctxt);
 +			return (1);
 +		}
-+		if (pSig)
-+		{
++		if (pSig) {
 +			fwrite(pSig, 1, strlen(pSig), stdout);
 +			fwrite("\n", 1, 1, stdout);
@@ -7766,8 +8113,6 @@
 +		vopts.nSubjectRequired = nAllowUnsignedSubject;
 +		DKIMVerifyInit(&ctxt, &vopts);		/*- this is always successful */
-+		for (;;)
-+		{
-+			if ((i = read(0, Buffer, sizeof(Buffer) - 1)) == -1)
-+			{
++		for (;;) {
++			if ((i = read(0, Buffer, sizeof(Buffer) - 1)) == -1) {
 +				fprintf(stderr, "read: %s\n", strerror(errno));
 +				DKIMVerifyFree(&ctxt);
@@ -7783,25 +8128,24 @@
 +				break;
 +		}
-+		if (!ret)
-+		{
-+			if ((ret = DKIMVerifyResults(&ctxt, &sCount, &sSize)) != DKIM_SUCCESS)
++		if (!ret) {
++			ret = DKIMVerifyResults(&ctxt, &sCount, &sSize);
++			if (ret != DKIM_SUCCESS && ret != DKIM_3PS_SIGNATURE && ret != DKIM_NEUTRAL)
 +				dkim_error(ret);
 +			if ((ret = DKIMVerifyGetDetails(&ctxt, &nSigCount, &pDetails, szPolicy)) != DKIM_SUCCESS)
 +				dkim_error(ret);
-+			else
-+			{
-+				for (ret = 0,i = 0; i < nSigCount; i++) {
++			else {
++				for (ret = DKIM_FAIL, i = 0; i < nSigCount; i++) {
 +					if (verbose)
 +						printf("Signature # %02d: ", i + 1);
-+					if (pDetails[i].nResult >= 0)
-+					{
++					if (pDetails[i].nResult >= 0) {
++						ret = 0;
 +						if (verbose)
 +							printf("Success\n");
 +						continue;
-+					} else
-+					{
-+						ret = pDetails[i].nResult;
++					} else {
++						if (ret == DKIM_FAIL)
++							ret = pDetails[i].nResult;
 +						if (verbose)
-+							printf("Failure %d\n", ret);
++							printf("Failure %d\n", pDetails[i].nResult);
 +					}
 +				}
@@ -7811,6 +8155,5 @@
 +		} 
 +		if (ret < 0 || ret == DKIM_3PS_SIGNATURE) {
-+			if (useADSP)
-+			{
++			if (useADSP) {
 +				char           *domain;
 +	
@@ -7826,6 +8169,5 @@
 +				ret = DKIM_NEUTRAL;
 +			} else
-+			if (useSSP)
-+			{
++			if (useSSP) {
 +				int             bTestingPractices = 0;
 +				char           *domain;
@@ -7848,14 +8190,11 @@
 +		DKIMVerifyFree(&ctxt);
 +		writeHeader(ret, resDKIMSSP, resDKIMADSP, useSSP, useADSP);
-+		if ((dkimverify = getenv("DKIMVERIFY")))
-+		{
-+			if (ret < 0)
-+			{
++		if ((dkimverify = getenv("DKIMVERIFY"))) {
++			if (ret < 0) {
 +				if (dkimverify[str_chr(dkimverify, 'F' - ret)])
 +					ret = 14; /*- return permanent error */
 +				if (dkimverify[str_chr(dkimverify, 'f' - ret)])
 +					ret = 88; /*- return temporary error */
-+			} else
-+			{
++			} else {
 +				if (dkimverify[str_chr(dkimverify, 'A' + ret)])
 +					ret = 14; /*- return permanent error */
@@ -7873,5 +8212,5 @@
 +getversion_dkim_c()
 +{
-+	static char    *x = (char *) "$Id: dkim.c,v 1.19 2016-03-01 16:23:38+05:30 Cprogrammer Exp mbhangui $";
++	static char    *x = (char *) "$Id: dkim.c,v 1.23 2019-06-14 21:24:59+05:30 Cprogrammer Exp mbhangui $";
 +
 +	x++;
@@ -7879,5 +8218,5 @@
 diff -ruN ../netqmail-1.06-original/dkim.h netqmail-1.06/dkim.h
 --- ../netqmail-1.06-original/dkim.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkim.h	2018-04-03 14:46:51.364411606 +0200
++++ netqmail-1.06/dkim.h	2019-02-27 20:57:13.386025114 +0100
 @@ -0,0 +1,193 @@
 +/*
@@ -8076,8 +8415,11 @@
 diff -ruN ../netqmail-1.06-original/dkimbase.cpp netqmail-1.06/dkimbase.cpp
 --- ../netqmail-1.06-original/dkimbase.cpp	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimbase.cpp	2018-04-03 14:46:51.363411603 +0200
-@@ -0,0 +1,336 @@
++++ netqmail-1.06/dkimbase.cpp	2019-06-19 09:46:20.131250010 +0200
+@@ -0,0 +1,339 @@
 +/*
 + * $Log: dkimbase.cpp,v $
++ * Revision 1.5  2019-06-14 21:24:03+05:30  Cprogrammer
++ * BUG - honor body length tag in verification
++ *
 + * Revision 1.4  2017-09-05 10:58:26+05:30  Cprogrammer
 + * removed compiler warnings
@@ -8242,5 +8584,5 @@
 +				// process body line
 +				int Result = ProcessBody(m_Line, m_LinePos, bEOF);
-+				if (Result != DKIM_SUCCESS) {
++				if (Result != DKIM_SUCCESS && Result != DKIM_FINISHED_BODY) {
 +					m_LinePos = 0;
 +					return Result;
@@ -8410,5 +8752,5 @@
 +getversion_dkimbase_cpp()
 +{
-+	static char    *x = (char *) "$Id: dkimbase.cpp,v 1.4 2017-09-05 10:58:26+05:30 Cprogrammer Exp mbhangui $";
++	static char    *x = (char *) "$Id: dkimbase.cpp,v 1.5 2019-06-14 21:24:03+05:30 Cprogrammer Exp mbhangui $";
 +
 +	x++;
@@ -8416,5 +8758,5 @@
 diff -ruN ../netqmail-1.06-original/dkimbase.h netqmail-1.06/dkimbase.h
 --- ../netqmail-1.06-original/dkimbase.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimbase.h	2018-04-03 14:46:51.363411603 +0200
++++ netqmail-1.06/dkimbase.h	2019-02-27 20:57:13.386025114 +0100
 @@ -0,0 +1,72 @@
 +/*
@@ -8492,6 +8834,6 @@
 diff -ruN ../netqmail-1.06-original/dkimdns.cpp netqmail-1.06/dkimdns.cpp
 --- ../netqmail-1.06-original/dkimdns.cpp	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimdns.cpp	2018-04-03 14:46:51.364411606 +0200
-@@ -0,0 +1,322 @@
++++ netqmail-1.06/dkimdns.cpp	2019-05-23 15:12:30.128092884 +0200
+@@ -0,0 +1,329 @@
 +/*
 + * $Log: dns.cpp,v $
@@ -8671,6 +9013,11 @@
 +				n = rrdlen - txtpos;
 +			if ((*txt_strlen + n + 1) > txtlen) {
-+				if (!(ptr = (char *) realloc(txt, (*txt_strlen + n) * 2)))
++				if (!(ptr = (char *) realloc(txt, (*txt_strlen + n) * 2))) {
++					free(txt);
++					txtlen = 0;
++					*txt_strlen = 0;
 +					return DNS_MEM;
++				}
++				txt = ptr;
 +				txtlen = (*txt_strlen + n) * 2;
 +			}
@@ -8706,5 +9053,5 @@
 +	total = 0;
 +	if (!dnresultlen) {
-+		if (!(dnresult = (char *) malloc ((2 * PACKETSZ) * sizeof(char))))
++		if (!(dnresult = (char *) malloc((2 * PACKETSZ) * sizeof(char))))
 +			return DNS_MEM;
 +		dnresultlen = 2 * PACKETSZ;
@@ -8721,4 +9068,5 @@
 +			if ((total + len + 1) >= dnresultlen) {
 +				if (!(ptr = (char *) realloc(dnresult, (total + len) * 2))) {
++					free(dnresult);
 +					dnresultlen = 0;
 +					if (txtlen) {
@@ -8728,4 +9076,5 @@
 +					return DNS_MEM;
 +				}
++				dnresult = ptr;
 +				dnresultlen = (total + len) * 2;
 +			}
@@ -8818,5 +9167,5 @@
 diff -ruN ../netqmail-1.06-original/dkimdns.h netqmail-1.06/dkimdns.h
 --- ../netqmail-1.06-original/dkimdns.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimdns.h	2018-04-03 14:46:51.364411606 +0200
++++ netqmail-1.06/dkimdns.h	2019-02-27 20:57:13.387025103 +0100
 @@ -0,0 +1,54 @@
 +/*
@@ -8876,5 +9225,5 @@
 diff -ruN ../netqmail-1.06-original/dkimfuncs.cpp netqmail-1.06/dkimfuncs.cpp
 --- ../netqmail-1.06-original/dkimfuncs.cpp	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimfuncs.cpp	2018-04-03 14:46:51.364411606 +0200
++++ netqmail-1.06/dkimfuncs.cpp	2019-02-27 20:57:13.387025103 +0100
 @@ -0,0 +1,236 @@
 +/*
@@ -8965,5 +9314,5 @@
 +
 +int             DKIM_CALL
-+DKIMSignGetSig(DKIMContext *pSignContext, char *szPrivKey, char *szSignature, unsigned int nSigLength)
++DKIMSignGetSig(DKIMContext *pSignContext, char *szPrivKey, char *szSignature, int nSigLength)
 +{
 +	CDKIMSign      *pSign = (CDKIMSign *) ValidateContext(pSignContext, true);
@@ -9068,5 +9417,5 @@
 +DKIMVersion()
 +{
-+	return (char *) "1.4";
++	return (char *) "1.5";
 +}
 +
@@ -9116,8 +9465,26 @@
 diff -ruN ../netqmail-1.06-original/dkimsign.cpp netqmail-1.06/dkimsign.cpp
 --- ../netqmail-1.06-original/dkimsign.cpp	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimsign.cpp	2018-04-03 14:46:51.365411610 +0200
-@@ -0,0 +1,1016 @@
++++ netqmail-1.06/dkimsign.cpp	2020-04-10 18:20:19.279077900 +0200
+@@ -0,0 +1,1029 @@
 +/*
 + * $Log: dkimsign.cpp,v $
++ * Revision 1.17  2020-04-10 21:36:20+05:30  Cprogrammer
++ * fixed BUG with domain assignment
++ *
++ * Revision 1.16  2020-04-09 21:21:04+05:30  Cprogrammer
++ * check for null domain after DKIMDOMAIN replacement
++ *
++ * Revision 1.15  2019-06-26 19:08:18+05:30  Cprogrammer
++ * added sBouncedAddr variable for X-Bounced-Address header added by qmail-send for bounces
++ *
++ * Revision 1.14  2019-06-24 22:22:15+05:30  Cprogrammer
++ * use DKIMDOMAIN only if Return-Path, From, Sender header are empty
++ *
++ * Revision 1.13  2018-08-25 18:01:59+05:30  Cprogrammer
++ * fixed dkim signing for From address containing company name
++ *
++ * Revision 1.12  2018-05-23 13:07:58+05:30  Cprogrammer
++ * fixed compiler warnings
++ *
 + * Revision 1.11  2017-09-05 10:59:03+05:30  Cprogrammer
 + * removed compiler warnings
@@ -9387,22 +9754,13 @@
 +CDKIMSign::GetHeaderParams(const string & sHdr)
 +{
-+	string::size_type pos1, pos2;
-+
++	if (_strnicmp(sHdr.c_str(), "X-Bounced-Address:", 18) == 0)
++		sBouncedAddr.assign(sHdr.c_str() + 21);
++	else
 +	if (_strnicmp(sHdr.c_str(), "X", 1) == 0)
 +		return;
-+	if (_strnicmp(sHdr.c_str(), "From:", 5) == 0) {
++	if (_strnicmp(sHdr.c_str(), "From:", 5) == 0)
 +		sFrom.assign(sHdr.c_str() + 5);
-+		pos1 = sFrom.find('(');
-+		pos2 = sFrom.find(')');
-+		if (pos1 != 0 && pos1 != string::npos && pos2 != 0 && pos2 != string::npos)
-+			sFrom.erase(pos1, pos2);
-+	}
-+	if (_strnicmp(sHdr.c_str(), "Sender:", 7) == 0) {
++	if (_strnicmp(sHdr.c_str(), "Sender:", 7) == 0)
 +		sSender.assign(sHdr.c_str() + 7);
-+		pos1 = sSender.find('(');
-+		pos2 = sSender.find(')');
-+		if (pos1 != 0 && pos1 != string::npos && pos2 != 0 && pos2 != string::npos)
-+			sSender.erase(pos1, pos2);
-+	}
 +	if (_strnicmp(sHdr.c_str(), "Return-Path:", 12) == 0)
 +		sReturnPath.assign(sHdr.c_str() + 12);
@@ -9452,5 +9810,5 @@
 +				nSignThisTag = 1;
 +				IsRequiredHeader(sTag);	// remove from required header list
-+			} 
++			}
 +			// is this in the list of headers that must be signed?
 +			else
@@ -9599,32 +9957,38 @@
 +	if (!sFrom.empty())
 +		sAddress.assign(sFrom);
++	else /* use indimail's X-Bounced-Address header to find the domain that injected the bounce */
++	if (!sBouncedAddr.empty())
++		sAddress.assign(sBouncedAddr);
 +	else
 +		return false;
-+	// simple for now, beef it up later
-+	// remove '<' and anything before it
++	/*-
++	 * simple for now, beef it up later
++	 * remove '<' and anything before it
++	 */
 +	pos = sAddress.find('<');
 +	if (pos != string::npos)
-+		sAddress.erase(0, pos);
-+	// remove '>' and anything after it
++		sAddress.erase(0, pos + 1);
++
++	/* remove '>' and anything after it */
 +	pos = sAddress.find('>');
 +	if (pos != string::npos)
 +		sAddress.erase(pos, string::npos);
-+	// look for '@' symbol
-+	pos = sAddress.find('@');
-+	if (pos == string::npos)
-+		return false;
++	/* look for '@' symbol */
 +	if (sDomain.empty()) {
-+		p = getenv("DKIMDOMAIN");
-+		if (p && *p)
-+		{
-+			if (!(at = strchr(p, '@')))
-+				at = p;
-+			else
-+				at++;
-+			sDomain.assign(at);
-+		} else
++		pos = sAddress.find('@');
++		if (pos != string::npos)
 +			sDomain.assign(sAddress.c_str() + pos + 1);
-+		RemoveSWSP(sDomain);
-+	}
++		if (sDomain.empty()) {
++			p = getenv("DKIMDOMAIN");
++			if (p && *p) {
++				if (!(at = strchr(p, '@')))
++					at = p;
++				else
++					at++;
++				sDomain.assign(at);
++			}
++		}
++	}
++	RemoveSWSP(sDomain);
 +	return true;
 +}
@@ -9895,18 +10259,16 @@
 +		for (sptr = ptr, len = 0;*sptr;sptr++) {
 +			if (*sptr == '%')
-+				len += (int) strlen(dptr);
++				len += (int) strlen(dptr) + 1;
 +			else
 +				len++;
 +		}
-+		if (!(buf = new char[len])) {
++		if (!(buf = new char[len]))
 +			return DKIM_OUT_OF_MEMORY;
-+		}
 +		for (cptr = buf, sptr = ptr; *sptr; sptr++) {
 +			if (*sptr == '%') {
-+				strncpy(cptr, dptr, (len = strlen(dptr)));
++				memcpy(cptr, dptr, (len = strlen(dptr)));
 +				cptr += len;
-+			} else {
++			} else
 +				*cptr++ = *sptr;
-+			}
 +		}
 +		*cptr = 0;
@@ -10130,5 +10492,5 @@
 +getversion_dkimsign_cpp()
 +{
-+	static char    *x = (char *) "$Id: dkimsign.cpp,v 1.11 2017-09-05 10:59:03+05:30 Cprogrammer Exp mbhangui $";
++	static char    *x = (char *) "$Id: dkimsign.cpp,v 1.17 2020-04-10 21:36:20+05:30 Cprogrammer Exp mbhangui $";
 +
 +	x++;
@@ -10136,8 +10498,14 @@
 diff -ruN ../netqmail-1.06-original/dkimsign.h netqmail-1.06/dkimsign.h
 --- ../netqmail-1.06-original/dkimsign.h	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimsign.h	2018-04-03 14:46:51.366411614 +0200
-@@ -0,0 +1,108 @@
++++ netqmail-1.06/dkimsign.h	2020-04-10 18:39:39.483427628 +0200
+@@ -0,0 +1,115 @@
 +/*
 + * $Log: dkimsign.h,v $
++ * Revision 1.5  2019-06-26 19:09:07+05:30  Cprogrammer
++ * added sBouncedAddr variable for X-Bounced-Address header added by qmail-send for bounces
++ *
++ * Revision 1.4  2017-09-05 10:59:20+05:30  Cprogrammer
++ * removed compiler warnings
++ *
 + * Revision 1.3  2017-08-09 22:03:09+05:30  Cprogrammer
 + * initialized EVP_MD_CTX variables
@@ -10225,4 +10593,5 @@
 +	string          sSelector;
 +	string          sReturnPath;
++	string          sBouncedAddr; /*- used for bounces */
 +	string          sDomain;
 +	string          sIdentity;	// for i= tag, if empty tag will not be included in sig
@@ -10248,8 +10617,23 @@
 diff -ruN ../netqmail-1.06-original/dkimverify.cpp netqmail-1.06/dkimverify.cpp
 --- ../netqmail-1.06-original/dkimverify.cpp	1970-01-01 01:00:00.000000000 +0100
-+++ netqmail-1.06/dkimverify.cpp	2018-04-03 14:46:51.367411617 +0200
-@@ -0,0 +1,1285 @@
++++ netqmail-1.06/dkimverify.cpp	2019-06-19 09:47:20.017583230 +0200
+@@ -0,0 +1,1303 @@
 +/*
 + * $Log: dkimverify.cpp,v $
++ * Revision 1.23  2019-05-22 11:29:09+05:30  Cprogrammer
++ * fix for 32 bit systems where time_t is 4 bytes & encounters year 2038 issue
++ *
++ * Revision 1.22  2019-05-21 22:27:17+05:30  Cprogrammer
++ * increased buffer size
++ *
++ * Revision 1.21  2019-02-17 11:32:05+05:30  Cprogrammer
++ * made scope of sFromDomain static
++ *
++ * Revision 1.20  2018-12-14 11:05:20+05:30  Cprogrammer
++ * fixed 'conversion from 'int' to 'char' inside { }â for cross compiling on arm
++ *
++ * Revision 1.19  2018-08-08 23:56:27+05:30  Cprogrammer
++ * changed comment style
++ *
 + * Revision 1.18  2017-09-05 11:00:33+05:30  Cprogrammer
 + * removed extra whitespace
@@ -10329,4 +10713,5 @@
 +#include "config.h"
 +#endif
++#include "time_t_size.h"
 +#define _strnicmp strncasecmp
 +#define _stricmp strcasecmp
@@ -10340,5 +10725,5 @@
 +#include "dkimdns.h"
 +
-+#define MAX_SIGNATURES	10		// maximum number of DKIM signatures to process in a message
++#define MAX_SIGNATURES	10		/*- maximum number of DKIM signatures to process in a message */
 +
 +SignatureInfo::SignatureInfo(bool s)
@@ -10397,11 +10782,11 @@
 +
 +	for (;;) {
-+		// skip whitespace
++		/* skip whitespace */
 +		while (isswsp(*s))
 +			s++;
-+		// if at the end of the string, return success.  note: this allows a list with no entries
++		/* if at the end of the string, return success.  note: this allows a list with no entries */
 +		if (*s == '\0')
 +			return true;
-+		// get tag name
++		/*- get tag name -*/
 +		if (!isalpha(*s))
 +			return false;
@@ -10411,22 +10796,22 @@
 +		} while (isalnum(*s) || *s == '-');
 +		char           *endtag = s;
-+		// skip whitespace before equals
++		/*- skip whitespace before equals -*/
 +		while (isswsp(*s))
 +			s++;
-+		// next character must be equals
++		/*- next character must be equals -*/
 +		if (*s != '=')
 +			return false;
 +		s++;
-+		// null-terminate tag name
++		/*- null-terminate tag name -*/
 +		*endtag = '\0';
-+		// skip whitespace after equals
++		/*- skip whitespace after equals -*/
 +		while (isswsp(*s))
 +			s++;
-+		// get tag value
++		/*- get tag value -*/
 +		char           *value = s;
 +		while (*s != ';' && ((*s == '\t' || *s == '\r' || *s == '\n') || (*s >= ' ' && *s <= '~')))
 +			s++;
 +		char           *e = s;
-+		// make sure the next character is the null terminator (which means we're done) or a semicolon (not done)
++		/*- make sure the next character is the null terminator (which means we're done) or a semicolon (not done) -*/
 +		bool            done = false;
 +		if (*s == '\0')
@@ -10437,13 +10822,13 @@
 +			s++;
 +		}
-+		// skip backwards past any trailing whitespace
++		/*- skip backwards past any trailing whitespace -*/
 +		while (e > value && isswsp(e[-1]))
 +			e--;
-+		// null-terminate tag value
++		/*- null-terminate tag value -*/
 +		*e = '\0';
-+		// check to see if we want this tag
++		/*- check to see if we want this tag -*/
 +		for (unsigned i = 0; wanted[i] != NULL; i++) {
 +			if (strcmp(wanted[i], tag) == 0) {
-+				// return failure if we already have a value for this tag (duplicates not allowed)
++				/*- return failure if we already have a value for this tag (duplicates not allowed) -*/
 +				if (values[i] != NULL)
 +					return false;
@@ -10457,5 +10842,5 @@
 +}
 +
-+// Convert hex char to value (0-15)
++/*- Convert hex char to value (0-15) -*/
 +char
 +tohex(char ch)
@@ -10510,5 +10895,5 @@
 +DecodeBase64(char *ptr)
 +{
-+	static const char base64_table[256] =
++	static const signed char base64_table[256] =
 +		{ -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
 +		-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1,
@@ -10553,5 +10938,5 @@
 +WildcardMatch(const char *p, const char *s)
 +{
-+	// special case: An empty "g=" value never matches any addresses
++	/*- special case: An empty "g=" value never matches any addresses -*/
 +	if (*p == '\0')
 +		return false;
@@ -10582,8 +10967,8 @@
 +		char           *from = s;
 +		char           *to = s;
-+		char           *lt = NULL;	// pointer to less than character (<) which starts the address if found
++		char           *lt = NULL;	/*- pointer to less than character (<) which starts the address if found */
 +		while (*from != '\0') {
 +			if (*from == '(') {
-+				// skip over comment
++				/*- skip over comment -*/
 +				from++;
 +				for (int depth = 1; depth != 0; from++) {
@@ -10602,23 +10987,18 @@
 +			}
 +			else
-+			if (*from == ')') {
-+				// ignore closing parenthesis outside of comment
++			if (*from == ')') /*- ignore closing parenthesis outside of comment -*/
 +				from++;
-+			}
-+
 +			else
 +			if (*from == ',' || *from == ';') {
-+				// comma/selicolon ends the address
++				/*- comma/selicolon ends the address -*/
 +				from++;
 +				break;
 +			}
 +			else
-+			if (*from == ' ' || *from == '\t' || *from == '\r' || *from == '\n') {
-+				// ignore whitespace
++			if (*from == ' ' || *from == '\t' || *from == '\r' || *from == '\n') /*- ignore whitespace -*/
 +				from++;
-+			}
 +			else
 +			if (*from == '"') {
-+				// copy the contents of a quoted string
++				/*- copy the contents of a quoted string -*/
 +				from++;
 +				while (*from != '\0') {
@@ -10635,9 +11015,9 @@
 +			else
 +			if (*from == '\\' && from[1] != '\0') {
-+				// copy quoted-pair
++				/*- copy quoted-pair -*/
 +				*to++ = *from++;
 +				*to++ = *from++;
 +			} else {
-+				// copy any other char
++				/*- copy any other char -*/
 +				*to = *from++;
 +				// save pointer to '<' for later...
@@ -10648,5 +11028,5 @@
 +		}
 +		*to = '\0';
-+		// if there's < > get what's inside
++		/*- if there's < > get what's inside -*/
 +		if (lt != NULL) {
 +			start = lt + 1;
@@ -10655,5 +11035,5 @@
 +				*gt = '\0';
 +		} else {
-+			// look for and strip group name
++			/*- look for and strip group name -*/
 +			char           *colon = strchr(start, ':');
 +			if (colon != NULL) {
@@ -10686,5 +11066,5 @@
 +}
 +
-+// Init - save the options
++/*- Init - save the options -*/
 +int
 +CDKIMVerify::Init(DKIMVerifyOptions *pOptions)
@@ -10703,5 +11083,5 @@
 +}
 +
-+// GetResults - return the pass/fail/neutral verification result
++/*- GetResults - return the pass/fail/neutral verification result -*/
 +int
 +CDKIMVerify::GetResults(int *sCount, int *sSize)
@@ -10711,12 +11091,10 @@
 +	int             TestingFailures = 0;
 +	int             RealFailures = 0;
-+	list <string>   SuccessfulDomains;	// can contain duplicates
-+	/* get the From address's domain if we might need it */
-+	string          sFromDomain;
++	list <string>   SuccessfulDomains;	/* can contain duplicates */
++	string          sFromDomain; /*- get the From address's domain if we might need it -*/
 +
 +	for (list < SignatureInfo >::iterator i = Signatures.begin(); i != Signatures.end(); ++i) {
 +		if (i->Status == DKIM_SUCCESS) {
-+			if (!i->BodyHashData.empty()) {
-+				// check the body hash
++			if (!i->BodyHashData.empty()) { /*- check the body hash -*/
 +				unsigned char   md[EVP_MAX_MD_SIZE];
 +				unsigned        len = 0;
@@ -10727,8 +11105,7 @@
 +#endif
 +				if (!res || len != i->BodyHashData.length() || memcmp(i->BodyHashData.data(), md, len) != 0) {
-+					// body hash mismatch
-+					// if the selector is in testing mode...
-+					if (i->m_pSelector->Testing) {
-+						i->Status = DKIM_SIGNATURE_BAD_BUT_TESTING;	// todo: make a new error code for this?
++					/* body hash mismatch */
++					if (i->m_pSelector->Testing) { /* if the selector is in testing mode... */
++						i->Status = DKIM_SIGNATURE_BAD_BUT_TESTING;	/* todo: make a new error code for this? */
 +						TestingFailures++;
 +					} else {
@@ -10739,8 +11116,8 @@
 +				}
 +			} else {
-+				// hash CRLF separating the body from the signature
++				/* hash CRLF separating the body from the signature */
 +				i->Hash("\r\n", 2);
 +			}
-+			// check the header hash
++			/*- check the header hash -*/
 +			string          sSignedSig = i->Header;
 +			string          sSigValue = sSignedSig.substr(sSignedSig.find(':') + 1);
@@ -10756,5 +11133,5 @@
 +			if (i->HeaderCanonicalization == DKIM_CANON_NOWSP) {
 +				RemoveSWSP(sSignedSig);
-+				// convert "DKIM-Signature" to lower case
++				/* convert "DKIM-Signature" to lower case */
 +				sSignedSig.replace(0, 14, "dkim-signature", 14);
 +			}
@@ -10776,5 +11153,5 @@
 +				SuccessfulDomains.push_back(i->Domain);
 +			} else {
-+				// if the selector is in testing mode...
++				/* if the selector is in testing mode... */
 +				if (i->m_pSelector->Testing) {
 +					i->Status = DKIM_SIGNATURE_BAD_BUT_TESTING;
@@ -10789,6 +11166,6 @@
 +			|| i->Status == DKIM_SELECTOR_ALGORITHM_MISMATCH
 +			|| i->Status == DKIM_SELECTOR_KEY_REVOKED) {
-+			// treat these as failures
-+			// todo: maybe see if the selector is in testing mode?
++			/*- treat these as failures -*/
++			/*- todo: maybe see if the selector is in testing mode? -*/
 +			RealFailures++;
 +		}
@@ -10797,5 +11174,5 @@
 +		for (list < string >::iterator i = HeaderList.begin(); i != HeaderList.end(); ++i) {
 +			if (_strnicmp(i->c_str(), "From", 4) == 0) {
-+				// skip over whitespace between the header name and :
++				/*- skip over whitespace between the header name and : -*/
 +				const char     *s = i->c_str() + 4;
 +				while (*s == ' ' || *s == '\t')
@@ -10812,9 +11189,11 @@
 +		}
 +	}
-+	// if a signature from the From domain verified successfully, return success now
-+	// without checking the sender signing practices
++	/*-
++	 * if a signature from the From domain verified successfully,
++	 * return success now without checking the sender signing practices
++	 */
 +	if (SuccessCount > 0 && !sFromDomain.empty()) {
 +		for (list < string >::iterator i = SuccessfulDomains.begin(); i != SuccessfulDomains.end(); ++i) {
-+			// see if the successful domain is the same as or a parent of the From domain
++			/* see if the successful domain is the same as or a parent of the From domain */
 +			if (i->length() > sFromDomain.length())
 +				continue;
@@ -10870,13 +11249,13 @@
 +
 +
-+// ProcessHeaders - Look for DKIM-Signatures and start processing them
++/*- ProcessHeaders - Look for DKIM-Signatures and start processing them -*/
 +int
 +CDKIMVerify::ProcessHeaders(void)
 +{
 +
-+	// look for DKIM-Signature header(s)
++	/*- look for DKIM-Signature header(s) -*/
 +	for (list < string >::iterator i = HeaderList.begin(); i != HeaderList.end(); ++i) {
 +		if (_strnicmp(i->c_str(), "DKIM-Signature", 14) == 0) {
-+			// skip over whitespace between the header name and :
++			/*- skip over whitespace between the header name and : -*/
 +			const char     *s = i->c_str() + 14;
 +			while (*s == ' ' || *s == '\t')
@@ -10905,8 +11284,8 @@
 +			return (sig.Status);
 +		} else {
-+			// check the granularity
++			/*- check the granularity -*/
 +			if (!WildcardMatch(sel.Granularity.c_str(), sig.IdentityLocalPart.c_str()))
-+				sig.Status = DKIM_SELECTOR_GRANULARITY_MISMATCH;	// this error causes the signature to fail
-+			// check the hash algorithm
++				sig.Status = DKIM_SELECTOR_GRANULARITY_MISMATCH;	/* this error causes the signature to fail */
++			/*- check the hash algorithm -*/
 +#ifdef HAVE_EVP_SHA256
 +			if ((sig.m_nHash == DKIM_HASH_SHA1 && !sel.AllowSHA1) || (sig.m_nHash == DKIM_HASH_SHA256 && !sel.AllowSHA256))
@@ -10914,6 +11293,6 @@
 +			if ((sig.m_nHash == DKIM_HASH_SHA1 && !sel.AllowSHA1))
 +#endif
-+				sig.Status = DKIM_SELECTOR_ALGORITHM_MISMATCH;	// causes signature to fail
-+			// check for same domain
++				sig.Status = DKIM_SELECTOR_ALGORITHM_MISMATCH;	/* causes signature to fail */
++			/*- check for same domain -*/
 +			if (sel.SameDomain && _stricmp(sig.Domain.c_str(), sig.IdentityDomain.c_str()) != 0)
 +				sig.Status = DKIM_BAD_SYNTAX;
@@ -10921,5 +11300,5 @@
 +		if (sig.Status != DKIM_SUCCESS)
 +			continue;
-+		// initialize the hashes
++		/*- initialize the hashes -*/
 +#if OPENSSL_VERSION_NUMBER >= 0x10100000L
 +#ifdef HAVE_EVP_SHA256
@@ -10949,5 +11328,5 @@
 +#endif
 +#endif
-+		// compute the hash of the header
++		/*- compute the hash of the header -*/
 +		vector < list < string >::reverse_iterator > used;
 +		for (vector < string >::iterator x = sig.SignedHeaders.begin(); x != sig.SignedHeaders.end(); ++x) {
@@ -10955,5 +11334,5 @@
 +			for (i = HeaderList.rbegin(); i != HeaderList.rend(); ++i) {
 +				if (_strnicmp(i->c_str(), x->c_str(), x->length()) == 0) {
-+					// skip over whitespace between the header name and :
++					/*- skip over whitespace between the header name and : -*/
 +					const char     *s = i->c_str() + x->length();
 +					while (*s == ' ' || *s == '\t')
@@ -10965,5 +11344,5 @@
 +			if (i != HeaderList.rend()) {
 +				used.push_back(i);
-+				// hash this header
++				/*- hash this header -*/
 +				if (sig.HeaderCanonicalization == DKIM_CANON_SIMPLE)
 +					sig.Hash(i->c_str(), i->length());
@@ -10976,5 +11355,5 @@
 +					string          sTemp = *i;
 +					RemoveSWSP(sTemp);
-+					// convert characters before ':' to lower case
++					/*- convert characters before ':' to lower case -*/
 +					for (char *s = (char *)sTemp.c_str(); *s != '\0' && *s != ':'; s++) {
 +						if (*s >= 'A' && *s <= 'Z')
@@ -10986,14 +11365,12 @@
 +			}
 +		}
-+		if (sig.BodyHashData.empty()) {
-+			// hash CRLF separating headers from body
++		if (sig.BodyHashData.empty()) /*- hash CRLF separating headers from body -*/
 +			sig.Hash("\r\n", 2);
-+		}
 +		if (!m_AllowUnsignedFromHeaders) {
-+			// make sure the message has no unsigned From headers
++			/*- make sure the message has no unsigned From headers -*/
 +			list<string>::reverse_iterator i;
 +			for( i = HeaderList.rbegin(); i != HeaderList.rend(); ++i ) {
 +				if( _strnicmp(i->c_str(), "From", 4 ) == 0 ) {
-+					// skip over whitespace between the header name and :
++					/*- skip over whitespace between the header name and : -*/
 +					const char *s = i->c_str()+4;
 +					while (*s == ' ' || *s == '\t')
@@ -11001,5 +11378,5 @@
 +					if (*s == ':') {
 +						if (find(used.begin(), used.end(), i) == used.end()) {
-+							// this From header was not signed
++							/*- this From header was not signed -*/
 +							break;
 +						}
@@ -11008,5 +11385,5 @@
 +			}
 +			if (i != HeaderList.rend()) {
-+				// treat signature as invalid
++				/*- treat signature as invalid -*/
 +				sig.Status = DKIM_UNSIGNED_FROM;
 +				continue;
@@ -11035,5 +11412,5 @@
 +	do {
 +		if (*s < '0' || *s > '9')
-+			return false;		// returns false for an initial '\0'
++			return false;	/*- returns false for an initial '\0' */
 +		temp = temp * 10 + (*s - '0');
 +		if (temp < last)
@@ -11050,10 +11427,10 @@
 +
 +
-+// ParseDKIMSignature - Parse a DKIM-Signature header field
++/*- ParseDKIMSignature - Parse a DKIM-Signature header field -*/
 +int
 +CDKIMVerify::ParseDKIMSignature(const string &sHeader, SignatureInfo &sig)
 +{
 +
-+	// save header for later
++	/*- save header for later -*/
 +	sig.Header = sHeader;
 +	string          sValue = sHeader.substr(sHeader.find(':') + 1);
